<?php
/*
* config.php
* http://tasuke.dna.affrc.go.jp/
*
* Author: Jungsok Kim, Ryutaro Itoh
*
* Copyright (c) 2013 National Institute of Agrobiological Sciences   
*
* This software is released under the MIT License.
*
* http://opensource.org/licenses/mit-license.php
*/

  // Database connection
  $db   ="";
  $host ="localhost";
  $user ="";
  $pswd ="";
  
  // Back-end database
  // Set mysql or oracle to $backend.
  // mysql: It requires php-mysql module.
  // oracle: It requires oci8 module.
  $backend="mysql";
  
  // Cache system using Redis (Beta)
  // Set "enabled" or "disabled" to $useRedis.
  $useRedis = "disabled";
  $redisHost = "localhost";
  $redisPort = 6379;
  $redisDBName = 0;
  
  // Name of reference
  $reference="Reference";

  // External link from track (Link destination URL)
  // e.g.) Set "http://tasuke.com/search?=" to $external_link and click "transcript001" on the track,
  //       link destination URL is "http://tasuke.com/search?=transcript001".
  $external_link="";
  
  // Destination tag for external link
  // This value means tag from gff file for external link url parameter.
  // If you set undefined tag to $external_link_tag_gff, it automatically sets "ID" to this value.
  $external_link_tag_gff="";
  
  //Suffix for external link
  // e.g.) Set ".html" to $external_link_suffix and click "transcript001" on the track,
  //       link destination URL is "http://tasuke.com/transcript001.html".
  $external_link_suffix="";
  
  // Initial name in front of chromosome name
  // usage: If $chromosome_name="chr";
  //        "01" -> "chr01"
  //        "02" -> "chr02"
  //        ..
  //        "12" -> "chr12"
  $chromosome_name="";

  // Primer3
  $primer3Path="/PATH/primer3_core";
  $primer3ThermPath="/PATH/primer3_config/";
  
  // PHYLIP directory
  $phylipDir="/PATH/";
  
  // Maximum level of zoom for viewing each nucleotide
  $nuc_max="4k";
  
  // Custom track 
  // Visualizing BAM, BED and BEDGrpah (RNA-seq read depth, CHIP-seq, BS-seq...)
  // Set "enabled" or "disabled" to $customTrack.
  $customTrack="disabled";
  
  //Track name for menu
  $customTrackName = "CustomTrack";
  
  //Kind of data name (Unit)
  $customTrackKindofData = "Value";
  
  //Normalizing based on number of read or not
  //It normalizes a value using header value of TSV file. It is useful for RNA-seq data.
  // Set "enabled" or "disabled" to $customTrackNormByRead.
  $customTrackNormByRead="disabled";
  
  // Condition name of the general purpose track that is used when viewing multiple condition. 
  $defaultCond = "";
  
  // Change color depth for custom track.
  $cstm_max=100;
  $cstm_min=0;
  
  //Canvas width for of accession ids and groups
  $accession_cvs_width=160;
  
  //Set any color to each accession groups(variety, sub varienty, origin, type).
  //Set "enabled" or "disabled" to $color_acc_group
  $color_acc_group="disabled";
  
  //Color definition
  //Set hex formatted value.
  //e.g.) $snp_max_col="#00FF00";
  //Color for maximum of SNP count
  $snp_max_col="#00FFFF";
  //Color for minimum of SNP count
  $snp_min_col="#F0F8FF";
  //Color for maximum of INDEL count
  $indel_max_col="#A52A2A";
  //Color for minimum of INDEL count
  $indel_min_col="#FFCB8E";
  //Color for maximum of DEPTH value
  $depth_max_col="#000000";
  //Color for minimum of DEPTH value
  $depth_min_col="#F2F2F2";
  //Color for maximum of custom track value
  $cstm_max_col="#A229B8";
  //Color for minimum of custom track value
  $cstm_min_col="#F5E9F7";
  //Color for maximum and minimum of custom track value when multiple conditions were enabled.
  $cstm_max_col_para1="#77ab42";
  $cstm_min_col_para1="#f1f6ec";
  $cstm_max_col_para2="#a13b4b";
  $cstm_min_col_para2="#f5ebed";
  $cstm_max_col_para3="#1a5dd9";
  $cstm_min_col_para3="#e8eefb";
  
  // Maximum of depth value in display
  $depth_max=140;
  $depth_min=0;
  
  // Maximum of SNP count by each level of zoom
  $snp_100k=1000;
  $snp_90k=900;
  $snp_80k=800;
  $snp_70k=700;
  $snp_60k=600;
  $snp_50k=500;
  $snp_40k=400;
  $snp_30k=300;
  $snp_20k=200;
  $snp_10k=100;
  $snp_9k=90;
  $snp_8k=80;
  $snp_7k=70;
  $snp_6k=60;
  $snp_5k=50;
  $snp_4k=40;
  $snp_3k=30;
  $snp_2k=20;
  $snp_1k=10;
  $snp_900b=9;
  $snp_800b=8;
  $snp_700b=7;
  $snp_600b=6;
  $snp_500b=5;
  $snp_400b=4;
  $snp_300b=3;
  $snp_200b=2;
  $snp_100b=1;
  $snp_90b=1;
  $snp_80b=1;
  $snp_70b=1;
  $snp_60b=1;
  $snp_50b=1;
  $snp_40b=1;
  $snp_30b=1;
  $snp_20b=1;
  $snp_10b=1;
  $snp_9b=1;
  $snp_8b=1;
  $snp_7b=1;
  $snp_6b=1;
  $snp_5b=1;
  $snp_4b=1;
  $snp_3b=1;
  $snp_2b=1;
  $snp_1b=1;
  $snp_min=1;
  
  
  // Maximum of INDEL count by each level of zoom
  $indel_100k=100;
  $indel_90k=90;
  $indel_80k=80;
  $indel_70k=70;
  $indel_60k=60;
  $indel_50k=50;
  $indel_40k=40;
  $indel_30k=30;
  $indel_20k=20;
  $indel_10k=10;
  $indel_9k=6;
  $indel_8k=6;
  $indel_7k=6;
  $indel_6k=6;
  $indel_5k=6;
  $indel_4k=3;
  $indel_3k=3;
  $indel_2k=3;
  $indel_1k=3;
  $indel_900b=1;
  $indel_800b=1;
  $indel_700b=1;
  $indel_600b=1;
  $indel_500b=1;
  $indel_400b=1;
  $indel_300b=1;
  $indel_200b=1;
  $indel_100b=1;
  $indel_90b=1;
  $indel_80b=1;
  $indel_70b=1;
  $indel_60b=1;
  $indel_50b=1;
  $indel_40b=1;
  $indel_30b=1;
  $indel_20b=1;
  $indel_10b=1;
  $indel_9b=1;
  $indel_8b=1;
  $indel_7b=1;
  $indel_6b=1;
  $indel_5b=1;
  $indel_4b=1;
  $indel_3b=1;
  $indel_2b=1;
  $indel_1b=1;
  $indel_min=1;

?>
